typedef unsigned int u_int32_t;

#define NULL 0

void int3(void);
#pragma aux int3 = 0xCC;
void nop(void);
#pragma aux nop = 0x90;
void sti(void);
#pragma aux sti = 0xFB;
void hlt(void);
#pragma aux hlt = 0xF4;

void AtUnload(void*);
void ExitThread(int,int);
u_int32_t GetNLMHandle(void);
u_int32_t AllocateResourceTag(
	u_int32_t NLMHandle,
	char*	  text,
	u_int32_t RTag);
u_int32_t ReturnResourceTag(
	u_int32_t Resource);
u_int32_t AddPollingProcedureRTag(
	void*	  procedure,
	u_int32_t Resource);
/* um whum... */
u_int32_t RemovePollingProcedure(
	void*	  procedure);

unsigned long strtoul(char*, char**, int);

u_int32_t RTag;
u_int32_t NLMH;
int slow;
int slow2;

void ask(void) {
	if (!--slow) {
		slow = slow2;
		sti();
		nop();
		nop();
		hlt();
	}
}

int SleepInit(void) {
	RTag = AllocateResourceTag(NLMH, "VMWare sleeper", 0x52504C50);
	AddPollingProcedureRTag(ask, RTag);
	return 0;
}

int SleepRemove(void) {
	RemovePollingProcedure(ask);
	ReturnResourceTag(RTag);
	return 0;
}

void main(int argc, char* argv[]) {
	slow2 = 1;
	slow = 1;
	if (argc > 1) {
		slow2 = strtoul(argv[1], NULL, 0);
		if (slow2 < 1)
			slow2 = 1;
	}
	AtUnload(SleepRemove);
	NLMH = GetNLMHandle();
	SleepInit();
	ExitThread(-1, -1);
}
